%global momorel 4
%global src_year 2008
%global src_month 07
%global src_day 27
%global src_date %{src_year}-%{src_month}-%{src_day}
%global rel 0.%{src_year}%{src_month}%{src_day}.%{momorel}

Summary: FFmpeg Streaming Multimedia System
Name: ffmpeg
Version: 0.4.9
%global src_name %{name}-%{version}
%global src_extract_name %{name}-export-%{src_year}-%{src_month}-%{src_day}

#Release: %{momorel}m%{?dist}
Release: %{rel}m%{?dist}
License: GPL
Group: Development/Libraries
# Since CVS server at mplayerhq.hu is now unreachable, we get cvs tarball from gentoo mirror
#Source0: http://www.mirrorservice.org/sites/www.ibiblio.org/gentoo/distfiles/ffmpeg-%{version}-p%{src_year}%{src_month}%{src_day}.tar.bz2
Source0: ffmpeg-export-snapshot.tar.bz2

Patch0: ffmpeg-export-2008-06-01-pkg-config.patch
Patch1: CVE-2008-4866-utils.patch
Patch2: CVE-2008-4866-avformat.patch
Patch3: CVE-2008-4867-dca.patch
Patch4: ffmpeg-export-2008-07-27-CVE-2009-0385.patch
Patch5: CVE-2008-4868.patch
Patch6: CVE-2008-4869.patch

URL: http://ffmpeg.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildPreReq: libvorbis-devel, a52dec-devel, faad2-devel, lame-devel
BuildPreReq: libtheora-devel, faac-devel, xvid
BuildPreReq: x264-devel >= 0.0.721-0.20080703, libdca
BuildPreReq: zlib-devel >= 1.1.4-5m, SDL-devel, freetype-devel, imlib2-devel
Requires: SDL >= 1.2.7-9m, libpostproc
%ifarch x86_64 ia64 ppc64 sparc64
Provides: libavcodec.so()(64bit)
Provides: libavformat.so()(64bit)
%else
Provides: libavcodec.so
Provides: libavformat.so
%endif

### include local configuration
%{?include_specopt}
# just a sample
# %%define extraconfopt --enable-mp3lame
# --enable-libgsm --enable-dv1394

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming
server and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it
into several file formats based on DCT/motion compensation
encoding. Sound is compressed in MPEG audio layer 2 or using an AC3
compatible stream.

%package devel
Summary: Header files and static library for the ffmpeg codec library
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: imlib2-devel, SDL-devel, freetype-devel, zlib-devel, libogg-devel
Requires: libtheora-devel, libvorbis-devel

%description devel
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.
The command line interface is designed to be intuitive, in the sense that
ffmpeg tries to figure out all the parameters, when possible. You have
usually to give only the target bitrate you want. FFmpeg can also convert
from any sample rate to any other, and resize video on the fly with a high
quality polyphase filter.

Install this package if you want to compile apps with ffmpeg support.

%package -n libpostproc
Summary: Video postprocessing library from ffmpeg
Group: System Environment/Libraries
# We need to override version here... when libpostproc was built from
# MPlayer, it got up to 1.0-0.11.x) - mach barfs! :-(
#Version: 1.0.1
Provides: libpostproc-devel = %{version}-%{release}

%description -n libpostproc
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.

This package contains only ffmpeg's libpostproc post-processing library which
other projects such as transcode may use. Install this package if you intend
to use MPlayer, transcode or other similar programs.


%prep
#'
%setup -q -n %{src_extract_name} 
%patch0 -p1 -b .pkgconfig
%patch1 -p1 -b .CVE-2008-4866-utils~
%patch2 -p1 -b .CVE-2008-4866-avformat~
%patch3 -p1 -b .CVE-2008-4867-dca~
%patch4 -p1 -b .CVE-2009-0385~
%patch5 -p1 -b .CVE-2008-4868~
%patch6 -p1 -b .CVE-2008-4869~

%build
find . -name "CVS" | xargs rm -rf
%ifarch x86_64 ppc64
CFLAGS="%optflags" \
%else
CFLAGS="%optflags -fno-unit-at-a-time" \
%endif
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --mandir=%{_mandir} \
    --incdir=%{_includedir}/ffmpeg \
%if 1
    --extra-libs="-lX11" \
%endif
%ifarch x86_64 ppc64
    --extra-cflags="-fPIC -DHAVE_LRINTF" \
%endif
    --enable-libvorbis \
    --enable-libmp3lame \
    --enable-libtheora \
    --enable-libfaad --enable-libfaadbin \
    --enable-libfaac \
    --enable-libxvid \
    --enable-libx264 \
    --enable-liba52 --enable-liba52bin \
    --enable-postproc \
    --enable-shared \
    --enable-pthreads \
    --enable-gpl \
    --enable-swscale \
    --enable-avfilter --enable-avfilter-lavf \
    --disable-optimizations \
    --disable-stripping \
    %{?extraconfopt}

%{__make} %{?_smp_mflags}
# make -C doc
%{__make} documentation

%install
rm -rf %{buildroot}
%makeinstall \
    DESTDIR=%{buildroot} \
    BINDIR=%{buildroot}/%{_bindir} \
    SHLIBDIR=%{buildroot}%{_libdir} \
    LIBDIR=%{buildroot}%{_libdir}

sed -i 's/includedir=\/usr\/include\/ffmpeg/includedir=\/usr\/include/g' %{buildroot}%{_libdir}/pkgconfig/*.pc

# Remove unwanted files from the included docs
%{__cp} -a doc _docs
%{__rm} -rf _docs/{CVS,Makefile,*.1,*.texi,*.pl}

cd %{buildroot}%{_includedir}
 ln -sf       ffmpeg/libpostproc postproc
 ln -sf       postproc/postprocess.h postprocess.h
cd -

# old ffmpeg compat
cd %{buildroot}%{_includedir}/ffmpeg/
for inc in */*
do
  ln -sf $inc .
done
cd -

%clean
%{__rm} -rf %{buildroot}

%post
/sbin/ldconfig

%postun
if [ "$1" = 0 ]; then
    /sbin/ldconfig
fi

%pre -n libpostproc
# for upgrading from STABLE_4, dirty...
rm -rf %{_includedir}/postproc

%post -n libpostproc
/sbin/ldconfig

%postun -n libpostproc
/sbin/ldconfig

%files
%defattr(-, root, root, 0755)
%doc Changelog CREDITS README
%{_bindir}/*
%{_libdir}/*.so.*
%exclude %{_libdir}/libpostproc.so*
%{_libdir}/vhook/
%{_mandir}/man1/*

%files devel
%defattr(-, root, root, 0755)
%doc doc/*
%{_includedir}/ffmpeg/
%exclude %{_includedir}/ffmpeg/libpostproc
%{_libdir}/*.a
%{_libdir}/*.so
%exclude %{_libdir}/libpostproc.so
%{_libdir}/pkgconfig/*.pc
%exclude %{_libdir}/pkgconfig/libpostproc.pc

%files -n libpostproc
%defattr(-, root, root, 0755)
%{_includedir}/postprocess.h
%{_includedir}/postproc
%{_includedir}/ffmpeg/libpostproc
%{_libdir}/libpostproc.so*
%{_libdir}/pkgconfig/libpostproc.pc

%changelog
* Sat Mar 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.4.9-0.20080727.4m)
- [SECURITY] CVE-2008-4868 CVE-2008-4869
- import upstream changes (Patch5,6)

* Sun Mar 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.4.9-0.20080727.3m)
- [SECURITY] CVE-2009-0385
- import upstream changes (Patch4)

* Wed Feb 11 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.4.9-0.20080727.2m)
- [SECURITY] CVE-2008-4866 CVE-2008-4867
- apply the upstream patches (Patch1,2,3)

* Sun Jul 27 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.4.9-0.20080727.1m)
- update to 20080727

* Fri Jul  4 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080704.1m)
- update to 20080704

* Sun Jun  1 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080601.1m)
- update to 20080601

* Mon May  5 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4.9-0.20080505.2m)
- remove pkgconfig64.patch to enable build on x86_64

* Mon May  5 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080505.1m)
- update to 20080505

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.20080318.4m)
- rebuild against gcc43

* Mon Mar 31 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4.9-0.20080318.3m)
- add %%pre -n libpostproc for upgrading from STABLE_4

* Thu Mar 20 2008 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.4.9-0.20080318.2m)
- add pkgconfig64 patch for lib64

* Tue Mar 18 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080318.1m)
- header made compatible. 
- support IPhone/IPod mp4 mixer

* Tue Mar 18 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080316.3m)
- fix *.pc CFLAGS

* Sun Mar 16 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080316.2m)
- enable avfilter

* Sun Mar 16 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080316.1m)
- update to 20080316

* Sun Mar 16 2008 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.4.9-0.20080128.3m)
- add --enable-swscaler to configure

* Thu Jan 31 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4.9-0.20080128.2m)
- remove "integer.h" from avutil.h to build libquicktime-1.0.2

* Tue Jan 29 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20080128.1m)
- update to 20080129
- add BuildReq

* Fri Dec 21 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20071219.3m)
- rebuild against x264-0.0.712-0.20071219

* Wed Dec 19 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4.9-0.20071219.2m)
- fix build on x86_64

* Wed Dec 19 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20071219.1m)
- update to 20071219

* Sun Aug 12 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (0.4.9-0.20070507.2m)
- rebuild against libvorbis-1.2.0-1m

* Mon May  7 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.4.9-0.20070507.1m)
- update to 20070507
- delete x86_64-shared.patch

* Tue Apr 24 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.4.9-0.20070330.4m)
- revised x86_64-shared.patch with Yuta's advice

* Sun Apr 22 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.4.9-0.20070330.3m)
- add x86_64-shared.patch for --enable-shared problem on x86_64
-- this patch is from http://www.momo-i.org and modifided a little bit

* Thu Apr 12 2007 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20070330.2m)
- BuildPreReq: libdca and build with "--enable-dts"

* Thu Apr 05 2007 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20070330.1m)
- update to 20070330
- resync with freshrpms.net
- * Tue Jan  9 2007 Matthias Saou <http://freshrpms.net/> 0.4.9-0.8.20070109
- - Update to today's SVN codebase, fixes the non existing ffmpeg.pc refrence.
- - Add faad2 patch.
- * Fri Dec 15 2006 Matthias Saou <http://freshrpms.net/> 0.4.9-0.7.20061215
- - Update to today's SVN codebase.
- - Update gsm patch so that it still applies.
- - Remove no longer needed x264 patch.
- - Remove --disable-opts option for now, as the build fails without. It seems
-   like an option from -O3 might be required for inline asm to work on x86.
- * Tue Oct 24 2006 Matthias Saou <http://freshrpms.net/> 0.4.9-0.7.20060918
- - Try to update, but stick with 20060918 as linking "as needed" is causing
-   too much trouble for now (libdca and libmp3lame with libm functions).
- - Include patch to work with latest x264.
- - Update URL and remove non-%%date stuff since there are no more releases.
- - Change group to Applications/Multimedia since ffmpeg is an application.
- - Remove dc1394 support since the lib isn't available anymore anyway.
- * Mon Sep 18 2006 Matthias Saou <http://freshrpms.net/> 0.4.9-0.6.20060918
- - Update to today's SVN codebase.
- - Remove theora support, it seems to be gone...
- - Remove a52 patch as ffmpeg doesn't link against it anyway.
- - Make installlib works again, so don't manually install anymore.
- - Remove all prever stuff that hasn't been useful in ages.
- - Change postproc/postprocess.h to be a symlink.


* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4.9-0.20060517.7m)
- ffmpeg-devel Requires: freetype2-devel -> freetype-devel

* Sun Jan  7 2007 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.20060517.6m)
- enable ppc64

* Sun Jul 30 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.4.9-0.20060517.5m)
- remove ffmpeg-0.4.8-kernel2681.patch

* Tue May 30 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.4m)
- %%exclude %%{_libdir}/libpostproc.so in devel (libpostproc owns it)

* Tue May 30 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.4.9-0.20060517.3m)
- added -DHAVE_LRINTF in --extra-cflags for x86_64 configure option
- added a link for postprocess.h in /usr/include

* Fri May 26 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.2m)
- added --extra-libs="-lX11" to a configure option.
- - (a little mysterious... This is needed when compiling with x264-0.0.523-1m and this causes "undefined symbol" error at runtime. Then I removed this flag and it was built fine with x264-0.0.523-2m without "-lX11" the day before yesterday. But today, it can be build if and only if with "-lX11" today and ffmpeg works fine...what has changed??? )

* Wed May 24 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.1m)
- update to cvs snapshot 20060517
- - Since CVS server at mplayerhq.hu is unreachable now, we get cvs tarball from gentoo mirror :-P (http://mirror.gentoo.gr.jp/distfiles/)
- resync with freshrpms.net (ffmpeg-0.4.9-0.5.20060317.src.rpm)

* Sat Mar 11 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.20050208.6m)
- enable ppc.

* Sat Mar  4 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.20050208.5m)
- enable x86_64.

* Thu Nov  3 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20050208.4m)
- add gcc4patch. import Gentoo patch.
- Patch20: ffmpeg-0.4.9-gcc4.patch

* Wed Oct 19 2005 Toru Hoshina <t@momonga-linux.org>
- (0.4.9-0.20050208.3m)
- enable ia64.
- libpostproc should be installed prior to the ffmpeg.
- avoid conflict with the libpostproc from the mplayer.

* Sat May 07 2005 Toru Hoshina <t@momonga-linux.org>
- (0.4.9-0.20050208.2m)
- enable x86_64. no more lib64 patch.

* Sat May 07 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.20050208.1m)
- update to cvs version
- * Sat Jan 15 2005 Dag Wieers <dag@wieers.com> - 0.4.9-0.20041110.3
- - Exclude libpostproc.so* from ffmpeg package.

* Fri Feb 18 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-7m)
- add lib64 patch.

* Tue Feb 16 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.4.8-6m)
- roll buck to 0.4.8

* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.4.9-0.0.1.4m)
- rebuild against SDL-1.2.7-9m

* Fri Feb 11 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.0.1.3m)
- renew lib64 patch

* Wed Feb  9 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.9-0.0.1.2m)
- enable lame, faad, and a52 support

* Mon Feb  7 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.0.1.1m)
- update 0.4.9 pre1

* Mon Feb  7 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-5m)
- enable x86_64.

* Mon Oct 25 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (0.4.8-4m)
- append CFLAGS fno-unit-at-a-time for compilation problems.

* Sat Aug 28 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.4.8-3m)
- add Patch0: ffmpeg-0.4.8-kernel2681.patch

* Sat Apr 24 2004 Toru Hoshina <t@momomnga-linux.org>
- (0.1-7m)
- explicitly provides libavcodec.so and libavformat.so for anaconda.

* Thu Mar 18 2004 Toru Hoshina <t@momonga-linux.org>
- (0.4.8-2m)
- revised spec for enabling rpm 4.2.

* Wed Nov  5 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (0.4.8-1m)
- update to 0.4.8

* Tue Aug 26 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.7-1m)

* Tue Apr 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.6-0.20021210.2m)
- rebuild against zlib 1.1.4-5m

* Wed Dec 11 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021210.1m)

* Sun Nov 10 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021110.1m)

* Sat Sep  7 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20020907.1m)
- initial import to Momonga
